package body Currency is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   2.0
  -- Date      31 August 2017
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    2.0  31.08.2017 English version
  --  C.G.    1.1  20.03.2014 Adapted for Ada tasking course
  --  C.G.    1.0  03.10.2013 Created for Ada course
  --====================================================================

  function Itemize (Amount: Natural) return Denomination is
    Rest  : Natural := Amount;
    Result: Denomination (Piece);
  begin
    -- Reverse loop over all pieces P:
    --   The number of pieces P is the integer
    --   division of the rest by the value of
    --   the piece P.
    --   The new rest is the rest modulo the
    --   value of the piece P.
    for P in reverse Piece loop
      Result (P) := Rest  /  Value (P);
      Rest       := Rest rem Value (P);
    end loop;
    return Result;
  end Itemize;

  function Amount (Pieces: Denomination) return Natural is
    Result: Natural := 0;
  begin
    for P in Pieces'Range loop
      Result := Result + Pieces (P) * Value (P);
    end loop;
    return Result;
  end Amount;

end Currency;
