private package Ticket_Automaton.Languages.English_Texts is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.3
  -- Date      27 April 2022
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for Change
  --  C.G.    1.3  27.04.2022 HTML now works with Set_Text (Ada_GUI
  --                          issue 6); spacing for sel. ticket, amount
  --  C.G.    1.2  17.04.2022 Add title
  --  C.G.    1.1  13.04.2022 Help implemented
  --  C.G.    1.0  11.04.2022 Missing: Help, Revision
  --====================================================================

  Notice: constant Text :=
    (Title              => new String'("<font size=""5"">Ticket Automaton</font>"),
     --
     Short_Trip         => new String'("Short Trip"),
     City_Region        => new String'("City Region"),
     Metropole_Area     => new String'("Metropole Area"),
     Day_Ticket         => new String'("Day Ticket"),
     --
     Selected_Ticket    => new String'("Selected ticket" &  2 * "&nbsp;"),
     Amount_to_Pay      => new String'("Amount to Pay"   & 19 * "&nbsp;"),
     --
     Abort_Button       => new String'("Abort"),
     Purchase_Aborted   => new String'("Purchase aborted "),
     Customer           => new String'("by Customer"),
     Change_Problems    => new String'("because of Change Problems"),
     Timeout            => new String'("because of Timeout"),
   --Revision           => new String'("because of Revision"),
     Remove_Money       => new String'("Remove the money inserted"),
     --
     Accomplished       => new String'("Purchase Accomplished"),
     Remove_Ticket      => new String'("Remove the ticket "),
     Remove_Change      => new String'(" and the change"),
     --
     Language_Button    => new String'("Language"),
     Some_Languages     => new String'("Languages"),
     Choose_Language    => new String'("Choose a Language"),
     Selected_Language  => new String'("You have selected "),
     --
     Yes                => new String'("Yes"),
     No                 => new String'("No"),
     --
   --Transport_Services => new String'("Ada Transport Services"),
   --Emptying           => new String'("Automaton emptying"),
   --Statistics         => new String'("Sales Statistics"),
     --
     Instructions       => new String'("Instructions"),
     Happiness          => new String'("You will make a simple automaton very happy" & LF &
                                       "if you purchase a ticket from me." & LF &
                                       "." & (30 * '=') & "." & LF &
                                       "|   Each button press will greatly increase the    |"                & LF &
                                       "|  " & (18 * ' ') & "Ada Transport Services'"   & (18 * ' ') & "  |" & LF &
                                       "|  " & (15 * ' ') & "Gross National Happiness." & (16 * ' ') & "  |" & LF &
                                       "`" & (30 * '=') & ""),
     --
     Terms              => new String'("Terms of Transportation"),  -- it's not easy to nicely align variable width font
     Authorisation      => new String'("The tickets authorise rides in Ada Land on terms as hereinafter:" & LF &
                                       "*  Short Trip:           Once through a single chapter of the"    & LF &
                                       "                                 Reference Manual"                & LF &
                                       "*  City Region:        Once through the language kernel"          & LF &
                                       "*  Metropole Area: Once through the complete Reference Manual"    & LF &
                                       "*  Day Ticket:          Lifelong through Ada Land"                & LF &
                                       "Frontier crossing into other coutries is permitted on terms as"   & LF &
                                       "specified in Annex B."                                            & LF &
                                       "Frontier crossing into any other country is prohibited."));

end Ticket_Automaton.Languages.English_Texts;
