with Ticket_Automaton.Languages.Deutsche_Texte,
     Ticket_Automaton.Languages.English_Texts,
     Ticket_Automaton.Languages.Textos_Castillanos,
     Ticket_Automaton.Languages.Texte_Francais,
     Ticket_Automaton.Languages.Testi_Italiani;

package body Ticket_Automaton.Languages is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.2
  -- Date      18 August 2022
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Author Version   Date    Reason for Change
  --  C.G.    1.2  18.08.2022 Add Castillano
  --  C.G.    1.1  13.04.2022 Clean up
  --  C.G.    1.0  11.04.2022
  --====================================================================

  Current: Language_Name := English;

  function Current_Language return Language_Name is (Current);

  procedure Set (Language: Language_Name) is
  begin
    case Language is
      when Deutsch    => Message := Deutsche_Texte    .Meldung;
      when English    => Message := English_Texts     .Notice;
      when Franais   => Message := Texte_Francais    .Message;
      when Italiano   => Message := Testi_Italiani    .Notizia;
      when Castillano => Message := Textos_Castillanos.Mensaje;
    end case;
    Current := Language;
   end Set;

  procedure Initialize is
  begin
    Message := English_Texts.Notice;
  end Initialize;

end Ticket_Automaton.Languages;
