with Ada.Characters.Latin_1, Ada.Strings.Fixed;

private package Ticket_Automaton.Languages is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.4
  -- Date      18 August 2022
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Author Version   Date    Reason for Change
  --  C.G.    1.4  18.08.2022 Add Castillano
  --  C.G.    1.3  27.04.2022 Add "*" for String parameter
  --  C.G.    1.2  17.04.2022 Add title
  --  C.G.    1.1  13.04.2022 Help implemented
  --  C.G.    1.0  11.04.2022 Missing: Revision, Help
  --====================================================================

  LF: Character renames Ada.Characters.Latin_1.LF;
  function "*" (N: Natural; C: Character) return String renames Ada.Strings.Fixed."*";
  function "*" (N: Natural; C: String)    return String renames Ada.Strings.Fixed."*";

  type String_Access is access String with Size => 100;

  type Purpose is (Title,
                   Short_Trip, City_Region, Metropole_Area, Day_Ticket,
                   Selected_Ticket, Amount_to_Pay,
                   Abort_Button, Purchase_Aborted, Customer, Change_Problems, Timeout, --Revision,
                                Remove_Money,
                   Accomplished, Remove_Ticket, Remove_Change,
                   Language_Button, Some_Languages, Choose_Language, Selected_Language,
                   Yes, No,
                   --Transport_Services, Emptying, Statistics,
                   Instructions, Happiness,
                   Terms, Authorisation);

  type Text is array (Purpose) of String_Access;

  Message: Text;

  type Language_Name is (Castillano, Deutsch, English, Franais, Italiano);

  function Current_Language return Language_Name;

  procedure Set (Language: Language_Name);

  procedure Initialize;  -- avoids elaboration problems

end Ticket_Automaton.Languages;
