with Gtk.Layout;
with Gtk.Image , Gtk.Label;

with Ada_9X_xpm.Image;

separate (Fahrkartenautomat)
procedure Aufstellen is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.3
  -- Datum     19 September 2021
  --====================================================================
  -- Die graphische Oberflche
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.3  19.09.2021 Abbruch bei Zeitberschreitung
  --  C.G.    1.2  15.09.2021 Callback fr Revision
  --  C.G.    1.1  12.09.2021 Character'Pos (164) als Euro-Platzhalter
  --  C.G.    1.0  11.09.2021
  --====================================================================

  Layout : Gtk.Layout.Gtk_Layout;

  --Lady: Gtk.Image.Gtk_Image;

  procedure Fahrkarte (Welche: out Gtk.Button.Gtk_Button;
                       Name  : in  String; XN: Glib.Gint;
                       Preis : in  String; XP: Glib.Gint) is
    Label: Gtk.Label.Gtk_Label;
  begin
    Gtk.Button.Gtk_New (Welche,  Name );
    Gtk.Label .Gtk_New (Label , +Preis);
    Gtk.Layout.Put (Layout, Welche, XN, Y =>  6);
    Gtk.Layout.Put (Layout, Label , XP, Y => 40);
    Button_Handler.Connect (Welche, "clicked", Callback.Start_Timeout'Access);
  end Fahrkarte;

  procedure Kaufen (Info: in out Gtk.GEntry.Gtk_GEntry; Text: String;
                    YT, Max, XE, YE: Glib.Gint) is
    Label: Gtk.Label.Gtk_Label;
  begin
    Gtk.Label .Gtk_New (Label, +Text);
    Gtk.GEntry.Gtk_New (Info);
    Gtk.GEntry.Set_Editable (Info, False);
    Gtk.GEntry.Set_Width_Chars (Info, Max);
    Gtk.Layout.Put (Layout, Label, X => 145, Y => YT);
    Gtk.Layout.Put (Layout, Info, XE, YE);
  end Kaufen;

  procedure Zahlen (Geld: out Gtk.Button.Gtk_Button;
                    Wert: in  String; X, Y: Glib.Gint) is
  begin
    Gtk.Button.Gtk_New (Geld, +Wert);
    Gtk.Layout.Put (Layout, Geld, X, Y);
    Button_Handler.Connect (Geld, "clicked", Callback.Restart_Timeout'Access);
  end Zahlen;

begin

  Gtk.Window.Gtk_New (Automat);
  Gtk.Window.Set_Title (Automat, "Fahrkartenautomat");
  Gtk.Window.Set_Default_Size (Automat, Width => 450, Height => 290);

  Gtk.Layout.Gtk_New (Layout);
  Gtk.Window.Add (Automat, Layout);

  Fahrkarte (Kurz  , Image (Kurzstrecke) ,  10, Image (Preis (Kurzstrecke)) ,  45);
  Fahrkarte (Innen , Image (Innenraum)   , 120, Image (Preis (Innenraum))   , 145);
  Fahrkarte (Gesamt, Image (Gesamtgebiet), 225, Image (Preis (Gesamtgebiet)), 260);
  Fahrkarte (Tag   , Image (Tageskarte)  , 345, Image (Preis (Tageskarte))  , 375);

  Kaufen (Wahl  , "Gewhlte Karte:"     , YT =>  72, Max => 11, XE => 270, YE => 66);
  Kaufen (Betrag, "Zu zahlender Betrag:", YT => 105, Max =>  7, XE => 298, YE => 99);

  -- Keine Warnung, wenn Datei nicht existiert.
  -- Es ist besser, sie einzubetten.
  -- Gtk.Image.Gtk_New (Lady, "Ada_9X.bmp");
  -- Gtk.Layout.Put (Layout, Lady, X => 10, Y => 72);
  -- Einbetten:
  Gtk.Layout.Put (Layout, Ada_9X_xpm.Image, X => 10, Y => 72);

  Gtk.Button.Gtk_New (Hilfe, "?");  -- Wie mache ich ein großes Fragezeichen?
  Gtk.Button.Set_Size_Request (Hilfe, Width => 62, Height => 62);
  Gtk.Layout.Put (Layout, Hilfe, X => 381, Y => 66);

  Zahlen (B_Cent_10, "10 ", X => 175, Y => 145);
  Zahlen (B_Cent_20, "20 ", X => 253, Y => 145);
  Zahlen (B_Cent_50, "50 ", X => 330, Y => 145);
  Zahlen (B_Euro_1 ,  "1 ", X => 149, Y => 183);
  Zahlen (B_Euro_2 ,  "2 ", X => 219, Y => 183);
  Zahlen (B_Euro_5 ,  "5 ", X => 288, Y => 183);
  Zahlen (B_Euro_10, "10 ", X => 358, Y => 183);

  Gtk.Button.Gtk_New (Abbruch, "Abbruch");
  Gtk.Layout.Put (Layout, Abbruch, X => 240, Y => 232);
  Button_Handler.Connect (Abbruch, "clicked", Callback.Stop_Timeout'Access);

  Gtk.Window.Show_All (Automat);

  Gtk.Button.On_Clicked (Kurz  , Callback.Karte'Access);
  Gtk.Button.On_Clicked (Innen , Callback.Karte'Access);
  Gtk.Button.On_Clicked (Gesamt, Callback.Karte'Access);
  Gtk.Button.On_Clicked (Tag   , Callback.Karte'Access);

  Gtk.Button.On_Clicked (B_Cent_10, Callback.Cent_10'Access);
  Gtk.Button.On_Clicked (B_Cent_20, Callback.Cent_20'Access);
  Gtk.Button.On_Clicked (B_Cent_50, Callback.Cent_50'Access);
  Gtk.Button.On_Clicked (B_Euro_1 , Callback.Euro_1'Access);
  Gtk.Button.On_Clicked (B_Euro_2 , Callback.Euro_2'Access);
  Gtk.Button.On_Clicked (B_Euro_5 , Callback.Euro_5'Access);
  Gtk.Button.On_Clicked (B_Euro_10, Callback.Euro_10'Access);

  Gtk.Button.On_Clicked (Abbruch, Callback.Abbruch'Access);

  Gtk.Button.On_Clicked (Hilfe, Callback.Hilfe'Access);

  Gtk.Window.On_Destroy (Automat, Callback.Revision'Access);

  --Gtk.Window.Set_Resizable (Automat, Resizable => False);  -- Was passiert hier?

end Aufstellen;

