with Ada.Strings.Fixed,
     Ada.Strings.UTF_Encoding.Strings;

function Fahrkartenautomat.Convert (Text: String) return Glib.UTF8_String is

  --====================================================================
  -- Autor    Christoph Grein
  -- Version  1.0
  -- Datum    12 September 2021
  --====================================================================
  -- Die Character-Position 164 ist das Whrungszeichen (Currency_Sign)
  -- in Latin_1, the Euro-Zeichen (Euro_Sign) in Latin_9 (a GNAT
  -- specific package).
  -- Alles bis auf dieses Zeichen wird in UTF8 konvertiert; das Zeichen
  -- selbst wird durch die UTF8-Sequenz des Euro-Zeichens ersetzt.
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    1.0  12.09.2021
  --====================================================================

  Euro: constant Glib.UTF8_String := Character'Val (16#E2#) & Character'Val (16#82#) & Character'Val (16#AC#);

  Found: constant Natural := Ada.Strings.Fixed.Index (Source => Text, Pattern => (1 => ''));

begin

  if Found = 0 then
    return Ada.Strings.UTF_Encoding.Strings.Encode (Text);
  else
    return Ada.Strings.UTF_Encoding.Strings.Encode (Text (Text'First .. Found - 1)) & Euro &
           Ada.Strings.UTF_Encoding.Strings.Encode (Text (Found + 1  .. Text'Last));
  end if;

end Fahrkartenautomat.Convert;
