private with Waehrung;

package Fahrkartenautomat is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   1.2
  -- Datum     22 Mrz 2023
  --====================================================================
  -- Das Paket dient der Simulation eines Fahrkartenautomaten.
  -- Fahrkarte whlen.
  -- Preis anzeigen. Geld eingeben.
  -- Prfung der eingegebenen Summe.
  -- Wenn genug: Fahrkarten- und Wechselgeldausgabe.
  -- Sonst Restpreis anzeigen.
  -- Alternativ kann auch Abbruch gewhlt werden, dann werden alle
  -- bisher eingegebenen Geldstcke wieder ausgeworfen. (Der Kunde
  -- berlegt es sich anders.)
  --
  -- Achtung:
  -- Es gibt eine wunderbare Geldvermehrung im Automaten.
  -- Versuchen Sie, ihn zu finden, und korrigieren Sie ihn.
  -- Hinweis: In der JEWL-Originalversion ist er korrigiert.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der Ąnderung
  --  C.G.    1.2  22.03.2023 Fehler-Info: Wunderbare Geldvermehrung
  --  C.G.    1.1  12.09.2021 Character'Pos (164) als Euro-Platzhalter
  --  C.G.    1.0  11.09.2021 Adaptiert von JEWL-Version 2.0
  --====================================================================

  procedure Aufstellen;

private

  type Fahrkartenoption is (Keine, Kurzstrecke, Innenraum, Gesamtgebiet, Tageskarte);
  subtype Fahrkarte is Fahrkartenoption range Kurzstrecke .. Tageskarte;

  function Image (Karte: Fahrkarte) return String;

  Preis: constant array (Fahrkarte) of Positive :=
    (Kurzstrecke  =>  1_50,
     Innenraum    =>  3_00,
     Gesamtgebiet =>  6_70,
     Tageskarte   => 11_10);

  use Waehrung;

  subtype Akzeptiertes_Geldstck is Geldstueck range Cent_10 .. Euro_10;
  subtype Stckelung is Waehrung.Stueckelung (Akzeptiertes_Geldstck);

  function Image (Geld: Integer) return String;

end Fahrkartenautomat;

