separate (Fahrkartenautomat)
package body Dagobert is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   2.2
  -- Datum     23 Mrz 2023
  --====================================================================
  --
  --====================================================================
  -- Geschichte
  -- Autor  Version   Datum   Grund der nderung
  --  C.G.    2.3  23.03.2023 Verkaufsstatistik neu
  --  C.G.    2.1  21.03.2023 Korrektur der wunderbaren Geldvermehrung
  --  C.G.    2.0  03.11.2020 Neue Implementierung
  --  C.G.    1.0  09.04.2014 Created for Ada tasking course
  --====================================================================

  Talerlein: Stckelung :=  -- frisch gefllte Maschine
    (Cent_10 => 20,         -- enthlt Geldstcke, damit
     Cent_20 => 10,         -- gewechselt werden kann;
     Cent_50 =>  5,         -- hier sehr knapp, sodass
     Euro_1  => 10,         -- Wechselprobleme bald
     Euro_2  =>  5,         -- auftauchen
     Euro_5  =>  5,
     Euro_10 =>  0);        -- als Wechelgeld unmglich

  -- Mit nchst kleinerer Mnze
  E5: constant Stckelung := (Euro_2  => 2, Euro_1  => 1, others => 0);
  E2: constant Stckelung := (Euro_1  => 2,               others => 0);
  E1: constant Stckelung := (Cent_50 => 2,               others => 0);
  C5: constant Stckelung := (Cent_20 => 2, Cent_10 => 1, others => 0);
  C2: constant Stckelung := (Cent_10 => 2,               others => 0);

  Geschft: Verkaufsstatistik := (others => 0);  -- Statistik der gakauften Fahrkarten

  --------------------------------------------------------------------------

  function "+" (L, R: Stckelung) return Stckelung
    with Inline
  is
    Zwerg: Stckelung;
  begin
    for M in Zwerg'Range loop
      Zwerg (M) := L (M) + R (M);
    end loop;
    return Zwerg;
  end "+";

  function "*" (L: Natural; R: Stckelung) return Stckelung
    with Inline
  is
    Zwerg: Stckelung;
  begin
    for M in Zwerg'Range loop
      Zwerg (M) := L * R (M);
    end loop;
    return Zwerg;
  end "*";

  procedure Anpassen (M: in Akzeptiertes_Geldstck; Differenz: in Natural; Wechselgeld: in out Stckelung)
    with Inline
  is
    -- Teile fehlende Geldstcke in nchst kleinere Stcke
  begin
    Wechselgeld := (case M is
                      when Euro_5  => Wechselgeld + Differenz * E5,
                      when Euro_2  => Wechselgeld + Differenz * E2,
                      when Euro_1  => Wechselgeld + Differenz * E1,
                      when Cent_50 => Wechselgeld + Differenz * C5,
                      when Cent_20 => Wechselgeld + Differenz * C2,
                      when others  => Wechselgeld);
    -- Damit mglichst wenige Stcke im Wechselgeld sind,
    -- Umwandlung mehrerer Zehner in Zwanziger:
    if M in Euro_5 | Cent_50 then
      declare
        Zwanziger: Akzeptiertes_Geldstck renames Akzeptiertes_Geldstck'Pred (M);
        Zehner   : Akzeptiertes_Geldstck renames Akzeptiertes_Geldstck'Pred (Zwanziger);
      begin
        Wechselgeld (Zwanziger) := Wechselgeld (Zwanziger) +  Wechselgeld (Zehner) / 2;
        Wechselgeld (Zehner   ) := Wechselgeld (Zehner   ) - (Wechselgeld (Zehner) / 2) * 2;
      end;
    end if;
  end Anpassen;

  --------------------------------------------------------------------------

  procedure Speichere (Gewhlt       : in  Fahrkarte ;
                       Zurckzuzahlen: in  Natural   ;
                       Gezahlt       : in  Stckelung;
                       Wechselgeld   : out Stckelung;
                       Wechselproblem: out Boolean   ) is
    Inhalt   : Stckelung := Talerlein + Gezahlt;
    Differenz: Natural;
  begin
    Wechselgeld := Stueckle (Zurckzuzahlen) (Akzeptiertes_Geldstck);
    for M in reverse Inhalt'Range loop
      if Wechselgeld (M) <= Inhalt (M) then
        Inhalt (M) := Inhalt (M) - Wechselgeld (M);  -- gengend Stcke M
      else
        if M = Cent_10 then
          Wechselproblem := True;
          Wechselgeld    := Gezahlt;  -- nicht genug Wechselgeld im Speicher
          return;
        end if;
        Differenz       := Wechselgeld (M) - Inhalt (M);  -- das fehlt
        Wechselgeld (M) := Inhalt (M);                    -- nimm soviel wie da ist
        Inhalt      (M) := 0;                             -- aufgebraucht
        Anpassen (M, Differenz, Wechselgeld);             -- und nimm fr den Rest kleinere Stcke
      end if;
    end loop;
    Wechselproblem     := False;
    Talerlein          := Inhalt;
    Geschft (Gewhlt) := Geschft (Gewhlt) + 1;
  end Speichere;

  function Panzerknacker return Stckelung is
  begin
    return Talerlein;
  end Panzerknacker;

  function Statistik return Verkaufsstatistik is
  begin
    return Geschft;
  end Statistik;

end Dagobert;
