private package Fahrkartenautomat.GUI is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   2.3
  -- Datum     31 Mrz 2023
  --====================================================================
  -- Erzeugung der von JEWL erzeugten grafischen Oberflche und
  -- Kommandos.
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    2.3  31.03.2023 Kartenwahl ausgrauen,
  --                          Geldtasten unsichtbar,
  --                          neues Kommando Zeitberschreitung
  --  C.G.    2.2  23.03.2023 Verkaufsstatistik neu
  --  C.G.    2.1  04.11.2020 Hilfe-Taste neu
  --  C.G.    2.0  03.11.2020 Neue Implementierung mit JEWL
  --  C.G.    1.0  12.04.2014 Created with Text_IO for Ada tasking
  --                          course
  --====================================================================

  type GUI_Kommando is (Ende,  -- des Programms
                        -- Kartenwahl
                        Kurzstrecke, Innenraum, Gesamtgebiet, Tageskarte,
                        -- Bezahlen
                        Cent_10, Cent_20, Cent_50,
                        Euro_1, Euro_2, Euro_5, Euro_10,
                        -- Der Kunde berlegt sich's anders
                        Abbruch, Zeitberschreitung,
                        -- Bedienungsanleitung
                        Hilfe);
  subtype Kartenwahl is GUI_Kommando range Kurzstrecke .. Tageskarte;
  subtype Bezahlen   is GUI_Kommando range Cent_10     .. Euro_10;

  function Nchstes_Kommando return GUI_Kommando;  -- wartet bis Taste gedrckt

  procedure Bedienungsanleitung;

  procedure Anzeige_gewhlte_Karte (Karte: in String);

  -- Nicht-positive Werte lschen die Anzeige
  procedure Anzeige_Zu_Zahlen (Geld: in Integer);

  procedure Anzeige_Ausgabe (Wechselgeld: in Natural);
  procedure Anzeige_Abbruch (Rckgeld   : in Natural; Grund: in String);

  procedure Anzeige_Speicherinhalt    (Inhalt : in Stckelung);
  procedure Anzeige_Verkaufsstatistik (Verkauf: in Verkaufsstatistik);

  procedure Aktiviere_Karten_Tasten (Aktiv: in Boolean);
  function  Karten_Tasten_Aktiv     return     Boolean;

  procedure Zeige_Geld_Tasten   (Sichtbar: in Boolean);
  function  Geld_Tasten_Sichtbar   return     Boolean;

end Fahrkartenautomat.GUI;
