with Waehrung;
use  Waehrung;

package Fahrkartenautomat is

  --====================================================================
  -- Autor     Christoph Grein
  -- Version   2.1
  -- Datum     23 Mrz 2023
  --====================================================================
  -- Das Paket dient der Simulation eines Fahrkartenautomaten.
  -- Fahrkarte whlen.
  -- Preis anzeigen. Geld eingeben.
  -- Prfung der eingegebenen Summe.
  -- Wenn genug: Fahrkarten- und Wechselgeldausgabe.
  -- Sonst Restpreis anzeigen.
  -- Alternativ kann auch Abbruch gewhlt werden, dann werden alle
  -- bisher eingegebenen Geldstcke wieder ausgeworfen. (Der Kunde
  -- berlegt es sich anders.)
  --====================================================================
  -- Geschichte
  -- Autor  Version  Datum    Grund der nderung
  --  C.G.    2.1  23.03.2023 Verkaufsstatistik neu
  --  C.G.    2.0  28.10.2020 Design unabhngig von Implementierung
  --  C.G.    1.0  09.04.2014 Created for Ada tasking course w/o GUI
  --====================================================================

  type Fahrkartenoption is (Keine, Kurzstrecke, Innenraum, Gesamtgebiet, Tageskarte);
  subtype Fahrkarte is Fahrkartenoption range Kurzstrecke .. Tageskarte;

  type Verkaufsstatistik is array (Fahrkarte) of Natural;

  Preis: constant array (Fahrkarte) of Positive :=
    (Kurzstrecke  =>  1_50,
     Innenraum    =>  3_00,
     Gesamtgebiet =>  6_70,
     Tageskarte   => 11_10);

  subtype Akzeptiertes_Geldstck is Geldstueck range Cent_10 .. Euro_10;
  subtype Stckelung is Waehrung.Stueckelung (Akzeptiertes_Geldstck);

  type Ausgabe is record
    Gekauft : Fahrkartenoption;   -- Keine bei Abbruch
    Rckgeld: Stckelung;
  end record;

  procedure Kaufe_Karte (Ergebnis: out Ausgabe; Stop: out Boolean);

end Fahrkartenautomat;
