with Ada.Numerics.Big_Numbers.Big_Integers;
use  Ada.Numerics.Big_Numbers.Big_Integers;

function Image (N: Big_Positive) return String is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      7 July 2021
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  07.07.2021 Created for Ada course
  --====================================================================

  Im: constant String := N'Image;

  function Group (X: String) return String is
  begin
    if X'Length < 5 then
      return X;
    else
      return Group (X (X'First .. X'Last - 3)) &
             '_' & X (Integer'Max (X'Last - 2, X'First) .. X'Last);
    end if;
  end Group;

begin

  return Group (Im);

end Image;
