with Ada.Text_IO;
use  Ada.Text_IO;

with Ada.Numerics.Big_Numbers.Big_Reals, Ada.Numerics.Big_Numbers.Big_Integers;
use  Ada.Numerics.Big_Numbers.Big_Reals, Ada.Numerics.Big_Numbers.Big_Integers;

procedure Ten_to_the_80th_Power_Apples is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 October 2022
  --====================================================================
  -- See Christoph Pppe, Spektrum der Wissenschaft 11.2022.
  -- The smallest diophantine solution of the equation
  --    Apples     / (Bananas    + Pineapples) +
  --    Bananas    / (Pineapples + Apples    ) +
  --    Pineapples / (Apples     + Bananas   ) = 4
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.10.2022 Created for Ada course
  --====================================================================

  Apples    : constant Big_Real := To_Big_Real (154_476_802_108_746_166_441_951_315_019_919_837_485_664_325_669_565_431_700_026_634_898_253_202_035_277_999);
  Bananas   : constant Big_Real := To_Big_Real ( 36_875_131_794_129_999_827_197_811_565_225_474_825_492_979_968_971_970_996_283_137_471_637_224_634_055_579);
  Pineapples: constant Big_Real := To_Big_Real (  4_373_612_677_928_697_257_861_252_602_371_390_152_816_537_558_161_613_618_621_437_993_378_423_467_772_036);

  Four: constant Big_Real := Apples     / (Bananas    + Pineapples) +
                             Bananas    / (Pineapples + Apples    ) +
                             Pineapples / (Apples     + Bananas   );
begin

  Put_Line (Big_Real   'Image (             Four));
  Put_Line (Big_Integer'Image (Numerator   (Four)));
  Put_Line (Big_Integer'Image (Denominator (Four)));

end Ten_to_the_80th_Power_Apples;
