------------------------------------------------------------------------------
-- Checked and Unchecked Computation with SI Units
-- Copyright (C) 2006 Christoph Karl Walter Grein
--
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
--
-- As a special exception,  if other files  instantiate  generics from this
-- unit, or you link this unit with other files to produce an executable,
-- this unit does not by itself cause the resulting executable to be
-- covered by the GNU General Public License.  This exception does not
-- however invalidate any other reasons why the executable file might be
-- covered by the GNU Public License.
--
-- Author's homepage and email address:
--   http://home.T-Online.de/home/Christ-Usch.Grein/
--   Christ-Usch.Grein@T-Online.de
------------------------------------------------------------------------------

with Ada.Exceptions;
use  Ada.Exceptions;

with Ada.Text_IO;
use  Ada.Text_IO;

with Rational_Arithmetics.Text_IO;
use  Rational_Arithmetics, Rational_Arithmetics.Text_IO;

procedure Test_Rational_Text_IO is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      2 February 2006
  --====================================================================
  -- Test the text input output facility.
  -- The program reads the file Test_Rational_Text_IO.in and writes the
  -- result to standard output. Compare the output with that in file
  -- Test_Rational_Text_IO.out.expected - it must be identical.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  02.02.2006
  --====================================================================

  F: File_Type;

  R: Rational;

  Line: String (1 .. 30);
  Last: Natural;

begin

  Open (F, Name => "Test_Rational_Text_IO.in", Mode => In_File);
  Set_Input (F);

  while not End_of_File loop
    begin
      Get (R);
      Put (R);  New_Line;
    exception
      when E:others =>
        Get_Line (Line, Last);
        Put_Line (Exception_Name (E) & " => """ & Line (1 .. Last) & '"');
    end;
  end loop;

  Close (F);

end Test_Rational_Text_IO;
