with Sim_Pool_Objects;
use  Sim_Pool_Objects;

package Sample_Unit is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 January 2018
  --====================================================================
  -- A sample package with a global variable (storing program state)
  -- as might exist in an embedded program.
  -- For training purposes on a simulator, the code is adapted so that
  -- a snapshot may be taken at any time. Thus all global variables
  -- have to be saved in one central place: the Snapshot_Pool.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.01.2018 Created for Ada course
  --====================================================================

  -- Global: Some_Type := Some_Value;  This original Global variable is replaced by

  type Some_Type_Record is record
    Global: Some_Type := Some_Value;
  end record;

  type Some_Type_Access is access Some_Type_Record;
  for  Some_Type_Access'Storage_Pool use Snapshot_Pool;

  Pointer: Some_Type_Access := new Some_Type_Record;
  Global : Some_Type renames Pointer.Global;

end Sample_Unit;
