with System;

with Sim_Pools;  use type Sim_Pools.Storage_Count;

package Sim_Pool_Objects is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 January 2018
  --====================================================================
  -- This package defines the actual Snapshot_Pool used for snapshots.
  -- For the size, tentatively first use a big number.
  -- When the simulation program elaborates successfully, the value
  -- delivered by Fill_Level can be taken for the pool's size.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.01.2018 Created for Ada course
  --====================================================================

  Ki: constant := 1024;

  Snapshot_Pool: Sim_Pools.Sim_Pool (Size => 4_600 * Ki);  -- for package global variables

  Snapshot_Pool_Address: constant System.Address := Sim_Pools.Address (Snapshot_Pool);

  function Fill_Level return Sim_Pools.Storage_Count;

  procedure Copy_From (Address: in System.Address);
  pragma Inline (Copy_From);
  -- A previous snapshot can be restored into the Snapshot_Pool from Address.

end Sim_Pool_Objects;
