with Ada.Text_IO;
use  Ada.Text_IO;

with Ada.Containers.Ordered_Sets;

procedure FIGURE_FIGURE_Figure (Axiom: Positive := 1; Count: Positive) is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      14 November 2023
  --====================================================================
  -- Douglas R. Hofstadter
  -- Gdel, Escher, Bach: An Eternal Golden Braid
  --   Can you characterize the following set of integers (or its
  --   negative space)?
  --         1 3 7 12 18 26 35 45 56 69 ...
  --   How is this sequence like the FIGURE-FIGURE Figure?
  --
  -- Let F be this sequence, the foreground, f the last generated
  -- number in F, i.e. the maximum.
  -- Let n be a positive number.
  --
  -- Rule:  if n is not an element of F, then n + f is element of F.
  -- Axiom: 1 is element of F.
  --
  -- The axiom may be set freely. Count elements will be produced.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  14.11.2023 Created for Ada course
  --====================================================================

  package Positive_Sets is new Ada.Containers.Ordered_Sets (Positive);
  use Positive_Sets;

  Foreground: Set;  -- := [Axiom];  aggregates are Ada 2022

begin

  Insert (Foreground, Axiom);
  Put_Line (Last_Element (Foreground)'Image);

  for F in 1 .. Count loop
    if Find (Foreground, F) = No_Element then  -- F not in Foreground
      Insert (Foreground, F + Last_Element (Foreground));
      Put_Line (Last_Element (Foreground)'Image);
    end if;
  end loop;

end FIGURE_FIGURE_Figure;
