with Ada.Text_IO;
use  Ada.Text_IO;
with Ada.Strings.Fixed;
use  Ada.Strings.Fixed;

separate (Kaprekar_Number)
procedure Put_Line (X: Large_Integer; Base: Large_Number_Base; Power: Positive) is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      13 November 2019
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  13.11.2019 Created for public Ada course
  --====================================================================

  Image: String (1 .. 30);

  package Large_Integer_Text_IO is new Ada.Text_IO.Integer_IO (Large_Integer);
  use Large_Integer_Text_IO;

begin

  Put (X, Base => 10);

  if Base = 10 then

    Put (Image, X**2);  -- to Image
    Put_Line ("    " & Image (Index_Non_Blank (Image) .. Image'Last - Power) &
              ' '    & Image (Image'Last - Power + 1  .. Image'Last));

  else  -- strip base indication

    Put (Image, X, Number_Base (Base));  -- to Image
    Put ("  " & Image (Index (Image, "#") + 1 .. Image'Last - 1));  -- to output, skip base indication

    Put (Image, X**2, Number_Base (Base));  -- to Image
    Put_Line ("    " & Image (Index (Image, "#") + 1 .. Image'Last - 1 - Power) &
              ' '    & Image (Image'Last - Power     .. Image'Last - 1));

  end if;

end Put_Line;
