-- This is not an example of well-written Ada code.
-- It's been constructed to demonstrate the effect
-- of access T'Class versus access T on dispatching.

with Ada.Finalization;
with Ada.Text_IO;

procedure Selfreferencing_Initialize is

  package P is
    type T is new Ada.Finalization.Limited_Controlled with record
      Self: not null access T'Class := T'Unchecked_Access;
      --Self: not null access T := T'Unchecked_Access;
    end record;
    overriding procedure Initialize (X: in out T);
    not overriding procedure Foo (X: in out T);
  end P;

  package body P is
    procedure Initialize (X: in out T) is
    begin
      Ada.Text_IO.Put_Line ("Initialize'T");
      X.Foo;       -- no dispatch
      X.Self.Foo;  -- redispatch
    end Initialize;
    procedure Foo (X: in out T) is
    begin
      Ada.Text_IO.Put_Line ("Foo'T");
    end Foo;
  end P;

  package Q is
    use P;
    type S is new T with record
      J: Integer;
    end record;
    overriding procedure Initialize (X: in out S);
    overriding procedure Foo (X: in out S);
  end Q;

  package body Q is
    procedure Initialize (X: in out S) is
    begin
      X.J := -1;
      Ada.Text_IO.Put_Line ("Initialize'S " & X.J'Image);
      T (X).Initialize;
    end Initialize;
    procedure Foo (X: in out S) is
    begin
      Ada.Text_IO.Put_Line ("Foo'S");
      X.J := X.J + 1;
    end Foo;
  end Q;

  Y: Q.S;

begin

  Ada.Text_IO.Put_Line (Integer'Image (Y.J));

end Selfreferencing_Initialize;
