with Ada.Streams.Storage.Unbounded;

with Ada.Text_IO;
use  Ada.Text_IO;

procedure Stream_Attributes is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      16 November 2023
  --====================================================================
  -- The stream attributes 'Input and 'Output also handle the bounds,
  -- whereas 'Read and 'Write do not.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  16.11.2023 Created for Ada course
  --====================================================================

  Stream: aliased Ada.Streams.Storage.Unbounded.Stream_Type;

  type Index is (A, B, C, D, E);

  type Component is range -100 .. 100;

  type My_Type is array (Index range <>) of Component;

  procedure Show (X: My_Type) is
  begin
    Put_Line (X'First'Image & X'Last'Image & X'Image);
  end Show;

begin

  My_Type'Output (Stream'Access, (A => 4, B => 5));
  My_Type'Output (Stream'Access, (C => 7, E => 9, D => 8));

  -- GNAT result

  Show (My_Type'Input (Stream'Access));  -- AB
                                         -- [ 4,  5]
  Show (My_Type'Input (Stream'Access));  -- CE
                                         -- [ 7,  8,  9]

end Stream_Attributes;
