with Ada.Streams;

with Ada.Text_IO.Text_Streams;
use  Ada.Text_IO;

procedure Stream_Text is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 November 2023
  --====================================================================
  -- The stream attributes 'Input and 'Output also handle the bounds,
  -- whereas 'Read and 'Write do not.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.11.2023 Created for Ada course
  --====================================================================

  File: File_Type;

begin

  Create (File, Out_File, "Stream.txt");

  Put_Line (File, "Test text streams");

  declare

    type Index is (A, B, C, D, E);

    type Component is range -100 .. 100;

    type My_Type is array (Index range <>) of Component;

    procedure Show (X: My_Type) is
    begin
      Put_Line (X'First'Image & X'Last'Image & X'Image);
    end Show;

    Stream: constant Text_Streams.Stream_Access := Text_Streams.Stream (File);

    Item: String (2023 .. 2100);
    Last: Natural;

  begin

    My_Type'Output (Stream, (A => 4, B => 5));
    My_Type'Output (Stream, (C => 7, E => 9, D => 8));

    Put_Line (File, "End test");

    Reset (File, In_File);

    Get_Line (File, Item, Last);
    Put_Line (Item (Item'First .. Last));

    Show (My_Type'Input (Stream));
    Show (My_Type'Input (Stream));

    Get_Line (File, Item (2050 .. 2070), Last);
    Put_Line (Item (2050 .. Last));

  end;

  Close (File);

end Stream_Text;
