package UPN is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      30 January 2021
  --====================================================================
  -- Evaluate an integer Ada expression in Reverse Polish Notation.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  30.01.2021 Created for Ada course
  --====================================================================

  subtype Operand  is Character range 'A' .. 'Z';
  subtype Operator is Character with Static_Predicate => Operator in '-' | '+' | '*' | '/' | '^';

  type Values is array (Operand) of Integer
    with Default_Component_Value => 0;

  function Evaluate (Expression: String; Coefficients: Values) return Integer;

end UPN;
