package body Ternary_Representations.Classification is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 August 2022
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.08.2022 Created for Basic Ada Course
  --====================================================================

  function Direction (S: Standard_Ternary) return Clock_Direction is
    Last: constant Standard_Trit := S (S'Last);
    Diff: Integer range -2 .. 2;
  begin
    for P in reverse S'Range loop
      Diff := Last - S (P);
      case Diff is
        when -1 |  2 => return Clockwise;
        when  1 | -2 => return Counterclockwise;
        when    0    => null;
      end case;
    end loop;
    return Neither;
  end Direction;

end Ternary_Representations.Classification;
