package Ternary_Representations.Classification is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 August 2022
  --====================================================================
  -- A ternary is clockwise if the first change of a trit starting from
  -- the highest power is one of             0 -> 1 -> 2 -> 0;
  -- it is anticlockwise if the change is in 0 -> 2 -> 1 -> 0.
  -- Examples:
  -- 3#011# is clockwise
  -- 3#210# is counterclockwise
  -- 3#111# is neither
  -- (In the range 1 .. (3**n-3)/2, any ternary is either clockwise or
  -- anticlockwise.)
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.08.2022 Created for Basic Ada Course
  --====================================================================

  type Clock_Direction is (Clockwise, Counterclockwise, Neither);

  function Direction (S: Standard_Ternary) return Clock_Direction;

end Ternary_Representations.Classification;
