with Ada.Integer_Text_IO;
use  Ada.Integer_Text_IO;

procedure Ternary_Representations.Put (T: Ternary; Zero_Power_First: Boolean := True) is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 August 2022
  --====================================================================
  -- Put a ternary as a sequence of trits with Width = 2.
  -- If Zero_Power_First then the first trit's value is T*3**0,
  -- else its value is T*3**n, where n is the highest power.
  -- Examples:
  -- " 1 2 0 2" for 61 = 3#2021# with Zero_Power_First = True
  -- " 1 1-1 0" for 33           with Zero_Power_First = False
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.08.2022 Created for Basic Ada Course
  --====================================================================

begin

  if Zero_Power_First then

    for I of T loop
      Put (I, Width => 2);
    end loop;

  else

    for I of reverse T loop
      Put (I, Width => 2);
    end loop;

  end if;

end Ternary_Representations.Put;
