package body Ternary_Representations is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 August 2022
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.08.2022 Created for Basic Ada Course
  --====================================================================

  function Sum (T: Ternary) return Positive is
     R: Integer := 0;
   begin
     for P in T'Range  loop
       R := R + T (P) * 3**P;
     end loop;
     return R;
   end Sum;

  function Twos_Complement (S: Standard_Ternary) return Standard_Ternary is
  begin
    return C: Standard_Ternary (S'Range) do
      for P in S'Range loop
        C (P) := 2 - S (P);
      end loop;
    end return;
  end Twos_Complement;

  function to_Standard_Ternary (Number: Positive; Max_Power: Positive) return Standard_Ternary is
    T: Standard_Ternary (0 .. Max_Power);
    N: Natural := Number;
  begin
    for P in T'Range loop
      T (P) := N rem 3;
      N     := N  /  3;
    end loop;
    return T;
  end to_Standard_Ternary;

  function to_Bilateral_Ternary (Number: Positive; Max_Power: Positive) return Bilateral_Ternary is
    S: constant Standard_Ternary := to_Standard_Ternary (Number, Max_Power);
    B: Bilateral_Ternary (0 .. Max_Power);
    C: Trit range 0 .. 1 := 0;  -- carry
  begin
    for P in S'Range loop
      case C is
        when 0 => case S (P) is
                    when -1 => null;  -- impossible (compiler does not evaluate dynamic predicate)
                    when  0 |
                          1 => B (P) := S (P);
                    when  2 => B (P) := -1;    C := 1;
                  end case;
        when 1 => case S (P) is
                    when -1 => null;  -- impossible
                    when  0 => B (P) :=  1;    C := 0;
                    when  1 => B (P) := -1;
                    when  2 => B (P) :=  0;
                  end case;
      end case;
    end loop;
    return B;
  end to_Bilateral_Ternary;

end Ternary_Representations;
