with Ada.Text_IO, Ada.Integer_Text_IO;
use  Ada.Text_IO, Ada.Integer_Text_IO;

with Ternary_Representations.Put;
use  Ternary_Representations;

procedure Weigh is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      17 August 2022
  --====================================================================
  -- Given n weights 3**0 .. 3**(n-1), determine how to weigh any amount
  -- up to (3**n-1)/2.
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  17.08.2022 Created for Basic Ada Course
  --====================================================================

  Weights: constant := 4;  -- 1, 3, 9, 27

  Res_B: Bilateral_Ternary (0 .. Weights-1);

begin

  for Amount in 1 .. (3**Weights-1)/2 loop

    Res_B := to_Bilateral_Ternary (Amount, Max_Power => Weights-1);

    Put (Amount);  Put (" => ");

    Put (Res_B, Zero_Power_First => False);

    New_Line;

  end loop;

end Weigh;
