with Ada.Integer_Text_IO;
use  Ada.Integer_Text_IO;
with Ada.Strings.Fixed;
use  Ada.Strings.Fixed;

separate (DNA_Encoding)
package body Map is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   2.0
  -- Date      19 January 2018
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    2.0  19.01.2018 English version
  --  C.G.    1.0  02.04.2013 Created for Ada course
  --====================================================================

  function Image (C: Character) return Trits is
    Image: String (1 .. 9);  -- Maximal value 255 = 3#100110#
    Trits: String renames Image (3 .. 8);
  begin
    Put (To => Image, Item => Character'Pos (C), Base => 3);  -- e.g. "   3#120#"
    declare                                                   -- Pos      |
      Pos: constant Positive := Index_Non_Blank (Image);  -- base indication, i.e. 3
    begin
      Trits (3 .. Pos + 1) := (Pos - 1) * '0';  -- fill with 0
    end;
    return Trits;
  end Image;

  function Value (T: Trits) return Character is
  begin
    return Character'Val (Integer'Value ("3#" & T & '#'));
  end Value;

end Map;
