package body Genetics is

  --====================================================================
  -- Author    Christoph Grein
  -- Version   1.0
  -- Date      2 October 2019
  --====================================================================
  --
  --====================================================================
  -- History
  -- Author Version   Date    Reason for change
  --  C.G.    1.0  02.10.2019 Created for Ada course
  --====================================================================

  function Hamming_Distance (Strand_1, Strand_2: DNA) return Natural is
    Distance: Natural := 0;
    -- Be careful: Strands need not have same index ranges;
    -- subtype conversion slides the bounds to the ones of Strand_1.
    -- Note: There is no copying implied!
    subtype DNA_1 is DNA (Strand_1'Range);
  begin
    for N in Strand_1'Range loop
      if Strand_1 (N) /= DNA_1 (Strand_2) (N) then
        Distance := Distance + 1;
      end if;
    end loop;
    return Distance;
  end Hamming_Distance;

end Genetics;
